Index: trunk/src/lib/graphics/importer/movie_player.h
===================================================================
--- trunk/src/lib/graphics/importer/movie_player.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/movie_player.h	(revision 9869)
@@ -31,4 +31,5 @@
 class MoviePlayer : public BaseObject
 {
+  ObjectListDeclaration(MoviePlayer);
 
 private:
Index: trunk/src/lib/graphics/importer/objModel.cc
===================================================================
--- trunk/src/lib/graphics/importer/objModel.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/objModel.cc	(revision 9869)
@@ -18,7 +18,6 @@
 #include "objModel.h"
 
-#include <stdio.h>
 #include <string.h>
-#include <stdlib.h>
+#include "loading/resource_manager.h"
 
 #define PARSELINELENGTH 8192
@@ -27,4 +26,5 @@
 #include "compiler.h"
 
+ObjectListDefinition(OBJModel);
 /**
  * @brief Crates a 3D-Model, loads in a File and scales it.
@@ -35,9 +35,9 @@
   : StaticModel(fileName)
 {
-  this->setClassID(CL_OBJ_MODEL, "OBJModel");
+  this->registerObject(this, OBJModel::_objectList);
 
   this->objPath = "./";
 
-  this->scaleFactor = scaling;
+  this->setScaleFactor(scaling);
 
   this->importFile (fileName);
@@ -77,5 +77,5 @@
   else
     this->objPath = "./";
-  Material::addTexturePath(this->objPath);
+  Resources::ResourceManager::getInstance()->addResourcePath("Texture", this->objPath);
 
   this->readFromObjFile (fileName);
Index: trunk/src/lib/graphics/importer/objModel.h
===================================================================
--- trunk/src/lib/graphics/importer/objModel.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/objModel.h	(revision 9869)
@@ -12,24 +12,25 @@
 class OBJModel : public StaticModel
 {
- public:
-   OBJModel(const std::string& fileName, float scaling = 1.0);
+  ObjectListDeclaration(OBJModel);
+public:
+  OBJModel(const std::string& fileName, float scaling = 1.0);
   virtual ~OBJModel();
 
- private:
+private:
   ///// readin /////
-   bool importFile (const std::string& fileName);
-   bool readFromObjFile (const std::string& fileName);
-   bool readMtlLib (const std::string& matFile);
+  bool importFile (const std::string& fileName);
+  bool readFromObjFile (const std::string& fileName);
+  bool readMtlLib (const std::string& matFile);
 
-  private:
-   void setIllum (Material* material, const char* illum);
-   void setDiffuse (Material* material, const char* rgb);
-   void setAmbient (Material* material, const char* rgb);
-   void setSpecular (Material* material, const char* rgb);
-   void setShininess (Material* material, const char* shini);
-   void setTransparency (Material* material, const char* trans);
+private:
+  void setIllum (Material* material, const char* illum);
+  void setDiffuse (Material* material, const char* rgb);
+  void setAmbient (Material* material, const char* rgb);
+  void setSpecular (Material* material, const char* rgb);
+  void setShininess (Material* material, const char* shini);
+  void setTransparency (Material* material, const char* trans);
 
- private:
-   std::string       objPath;     //!< The Path where the obj and mtl-file are located.
+private:
+  std::string       objPath;     //!< The Path where the obj and mtl-file are located.
 };
 
Index: trunk/src/lib/graphics/importer/resource_obj.cc
===================================================================
--- trunk/src/lib/graphics/importer/resource_obj.cc	(revision 9869)
+++ trunk/src/lib/graphics/importer/resource_obj.cc	(revision 9869)
@@ -0,0 +1,52 @@
+
+#include "resource_obj.h"
+#include "substring.h"
+#include "multi_type.h"
+#include "debug.h"
+
+
+ResourceOBJ::ResourceOBJ(const std::string& imageName, float scaling, const Resources::KeepLevel& keepLevel)
+    : Resource(&ResourceOBJ::type)
+{
+  Resources::StorePointer* ptr = this->acquireResource(imageName + ',' + MultiType(scaling).getString());
+
+  if (ptr)
+  {
+    PRINTF(5)("FOUND OBJ: %s\n", imageName.c_str());
+    this->acquireData(static_cast<ResourceOBJ::OBJResourcePointer*>(ptr)->ptr());
+  }
+  else
+  {
+    PRINTF(5)("NOT FOUND OBJ: %s\n", imageName.c_str());
+    std::string fileName = this->Resource::locateFile(imageName);
+    this->acquireData(OBJModel(fileName, scaling).dataPointer());
+    this->Resource::addResource(new ResourceOBJ::OBJResourcePointer(imageName + ',' + MultiType(scaling).getString(), keepLevel, this->StaticModel::dataPointer()));
+  }
+}
+
+ResourceOBJ ResourceOBJ::createFromString(const std::string& loadString, const Resources::KeepLevel& keepLevel)
+{
+  SubString loadValues(loadString, ',');
+  std::string imageName;
+  float scaling = 1.0f;
+  if (loadValues.size() > 0)
+    imageName = loadValues[0];
+  if (loadValues.size() > 1)
+    scaling = (GLenum)MultiType(loadValues[2]).getFloat();
+
+  return ResourceOBJ(imageName, scaling, keepLevel);
+}
+
+
+
+Resources::tType<ResourceOBJ> ResourceOBJ::type("OBJ");
+
+
+
+
+
+ResourceOBJ::OBJResourcePointer::OBJResourcePointer(const std::string& loadString, const Resources::KeepLevel& keepLevel, const StaticModelData::Pointer& data)
+    : Resources::StorePointer(loadString, keepLevel) , pointer(data)
+{}
+
+
Index: trunk/src/lib/graphics/importer/resource_obj.h
===================================================================
--- trunk/src/lib/graphics/importer/resource_obj.h	(revision 9869)
+++ trunk/src/lib/graphics/importer/resource_obj.h	(revision 9869)
@@ -0,0 +1,38 @@
+/*!
+ * @file resource_obj.h
+ * @brief Contains the ResourceOBJ class, that handles the Resource-specific loading part of the OBJ.
+ *
+ */
+
+#ifndef _RESOURCE_OBJ_H
+#define _RESOURCE_OBJ_H
+
+#include "util/loading/resource.h"
+#include "objModel.h"
+
+class ResourceOBJ : public StaticModel, public Resources::Resource
+{
+public:
+  ResourceOBJ(const std::string& imageName,
+	      float scaling = 1.0f,
+	      const Resources::KeepLevel& keepLevel = Resources::KeepLevel());
+  static ResourceOBJ createFromString(const std::string& loadString,
+				      const Resources::KeepLevel& keepLevel = Resources::KeepLevel());
+
+private:
+class OBJResourcePointer : public Resources::StorePointer
+  {
+  public:
+    OBJResourcePointer(const std::string& loadString, const Resources::KeepLevel& keepLevel, const StaticModelData::Pointer& data);
+    inline const StaticModelData::Pointer& ptr() const { return pointer; }
+    virtual bool last() const { return pointer.count() == 1; }
+private:
+    StaticModelData::Pointer pointer;
+  };
+
+private:
+  static Resources::tType<ResourceOBJ> type;
+};
+
+
+#endif /* _RESOURCE_OBJ_H */
Index: trunk/src/lib/graphics/importer/resource_texture.cc
===================================================================
--- trunk/src/lib/graphics/importer/resource_texture.cc	(revision 9869)
+++ trunk/src/lib/graphics/importer/resource_texture.cc	(revision 9869)
@@ -0,0 +1,52 @@
+
+#include "resource_texture.h"
+#include "substring.h"
+#include "multi_type.h"
+#include "debug.h"
+
+
+ResourceTexture::ResourceTexture(const std::string& imageName, GLenum target, const Resources::KeepLevel& keepLevel)
+    : Resource(&ResourceTexture::type)
+{
+  Resources::StorePointer* ptr = this->acquireResource(imageName + ',' + MultiType((int)target).getString());
+
+  if (ptr)
+  {
+    PRINTF(5)("FOUND TEXTURE: %s\n", imageName.c_str());
+    this->acquireData(static_cast<ResourceTexture::TextureResourcePointer*>(ptr)->ptr());
+  }
+  else
+  {
+    PRINTF(5)("NOT FOUND TEXTURE: %s\n", imageName.c_str());
+    std::string fileName = this->Resource::locateFile(imageName);
+    this->Texture::loadImage(fileName, target);
+    this->Resource::addResource(new ResourceTexture::TextureResourcePointer(imageName + ',' + MultiType((int)target).getString(), keepLevel, this->Texture::dataPointer()));
+  }
+}
+
+ResourceTexture ResourceTexture::createFromString(const std::string& loadString, const Resources::KeepLevel& keepLevel)
+{
+  SubString loadValues(loadString, ',');
+  std::string imageName;
+  GLenum target = GL_TEXTURE_2D;
+  if (loadValues.size() > 0)
+    imageName = loadValues[0];
+  if (loadValues.size() > 1)
+    target = (GLenum)MultiType(loadValues[2]).getInt();
+
+  return ResourceTexture(imageName, target, keepLevel);
+}
+
+
+
+Resources::tType<ResourceTexture> ResourceTexture::type("Texture");
+
+
+
+
+
+ResourceTexture::TextureResourcePointer::TextureResourcePointer(const std::string& loadString, const Resources::KeepLevel& keepLevel, const TextureData::Pointer& data)
+    : Resources::StorePointer(loadString, keepLevel) , pointer(data)
+{}
+
+
Index: trunk/src/lib/graphics/importer/resource_texture.h
===================================================================
--- trunk/src/lib/graphics/importer/resource_texture.h	(revision 9869)
+++ trunk/src/lib/graphics/importer/resource_texture.h	(revision 9869)
@@ -0,0 +1,39 @@
+/*!
+ * @file resource_texture.h
+ * @brief Contains the ResourceTexture class, that handles the Resource-specific loading part of the Texture.
+ *
+ */
+
+#ifndef _RESOURCE_TEXTURE_H
+#define _RESOURCE_TEXTURE_H
+
+#include "util/loading/resource.h"
+#include "texture.h"
+
+
+class ResourceTexture : public Texture, public Resources::Resource
+{
+public:
+  ResourceTexture(const std::string& imageName,
+                  GLenum target = GL_TEXTURE_2D,
+		  const Resources::KeepLevel& keepLevel = Resources::KeepLevel());
+  static ResourceTexture createFromString(const std::string& loadString,
+					  const Resources::KeepLevel& keepLevel = Resources::KeepLevel());
+
+private:
+class TextureResourcePointer : public Resources::StorePointer
+  {
+  public:
+    TextureResourcePointer(const std::string& loadString, const Resources::KeepLevel& keepLevel, const TextureData::Pointer& data);
+    inline const TextureData::Pointer& ptr() const { return pointer; }
+    virtual bool last() const { return pointer.count() == 1; }
+  private:
+    TextureData::Pointer pointer;
+  };
+
+private:
+  static Resources::tType<ResourceTexture> type;
+};
+
+
+#endif /* _RESOURCE_TEXTURE_H */
